> For the complete documentation index, see [llms.txt](https://docs.flashback.tech/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.flashback.tech/support-reference/supported-sdks/cloud-storage/google-gcs/node.js-with-custom-endpoint.md).

# Node.js with custom endpoint

```typescript
import { Storage } from '@google-cloud/storage';
import { FlashgateGCSStorage } from '@flashgatetech/flashgateclient/gcs';

const config = {
    apiEndpoint: process.env.TEST_GCS_AWS_PROVIDER_URL,
    tokenUri: process.env.TEST_GCS_AWS_PROVIDER_URL + '/token',
    credentials: {
      client_email: process.env.TEST_GCS_CLIENT_EMAIL!,
      private_key: process.env.TEST_GCS_PRIVATE_KEY,
    },
  },
}

// Use custom auth client with custom token endpoint
const tokenUri = config.tokenUri || `${config.apiEndpoint}/token`;
const authClient = new FlashgateAuthClient(
  tokenUri,
  config.credentials,
  [
    'https://www.googleapis.com/auth/devstorage.full_control',
    'https://www.googleapis.com/auth/devstorage.read_only',
    'https://www.googleapis.com/auth/devstorage.read_write'
  ]
);

const storage = new Storage({
  apiEndpoint: config.apiEndpoint,
  authClient,
  useAuthWithCustomEndpoint: true,
});

const bucket = storage.bucket(bucketName);

// 1. Check if bucket exists
try {
  const [exists] = await storage.bucket(bucketName).exists();
  expect(exists).toBe(true);
} catch (error) {
  console.error('Error checking bucket existence:', error);
  throw error;
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.flashback.tech/support-reference/supported-sdks/cloud-storage/google-gcs/node.js-with-custom-endpoint.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
